// CRTS2Dialog.cpp : implementation file
//

#include "stdafx.h"
#include "RTS2.h"
#include "CRTS2Dialog.h"
#include "SendDialog.h"
#include "ConnectDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

static int nextRefNum=0;

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRTS2Dialog dialog

CRTS2Dialog::CRTS2Dialog(CWnd* pParent /*=NULL*/)
	: CDialog(CRTS2Dialog::IDD, pParent)
{
	//{{AFX_DATA_INIT(CRTS2Dialog)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_DIALOG);
}

void CRTS2Dialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CRTS2Dialog)
	DDX_Control(pDX, IDC_DISCONNECT, m_disconnect);
	DDX_Control(pDX, IDC_CONNECT, m_connect);
	DDX_Control(pDX, IDC_RESPONSES, m_responses);
	DDX_Control(pDX, IDOK, m_ok);
	DDX_Control(pDX, IDC_SEND, m_send);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CRTS2Dialog, CDialog)
	//{{AFX_MSG_MAP(CRTS2Dialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SEND, OnSend)
	ON_BN_CLICKED(IDC_CONNECT, OnConnect)
	ON_BN_CLICKED(IDC_DISCONNECT, OnDisconnect)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CRTS2Dialog message handlers

BOOL CRTS2Dialog::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	CString strAboutMenu;
	strAboutMenu.LoadString(IDS_ABOUTBOX);
	if (!strAboutMenu.IsEmpty())
	{
		pSysMenu->AppendMenu(MF_SEPARATOR);
		pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CRTS2Dialog::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRTS2Dialog::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRTS2Dialog::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CRTS2Dialog::OnConnect() 
{
	CConnectDialog dlg(m_socket);

	// pop up a dialog
	if(dlg.DoModal()!=IDOK) return;

	// clear the close flag
	m_closeRequested=FALSE;
	// Start the thread
	AfxBeginThread(ReceiveThreadFunction,this);

	// disable the buttons
	m_connect.EnableWindow(FALSE);
	// disable the buttons
	m_disconnect.EnableWindow(TRUE);
	// disable the buttons
	m_send.EnableWindow(TRUE);
	// disable the buttons
	m_ok.EnableWindow(FALSE);
}

void CRTS2Dialog::OnDisconnect() 
{
	// disable the buttons
	m_disconnect.EnableWindow(FALSE);
	// disable the buttons
	m_send.EnableWindow(FALSE);
	// set the flag
	m_closeRequested=TRUE;
}

void CRTS2Dialog::OnSend() 
{
	CSendDialog dlg(m_socket);

	// pop up a dialog
	if(dlg.DoModal()!=IDOK) return;
	// send the request
	SendRequest(dlg.m_program,dlg.m_parameters);
}

UINT CRTS2Dialog::ReceiveThreadFunction(LPVOID pDialog)
{
	// use the dialog's member function
	((CRTS2Dialog *)pDialog)->DoReceiveLoop();
	// done
	return 0;
}

void CRTS2Dialog::DoReceiveLoop()
{
	char opcode;

	// read an opcode
	while(!m_closeRequested && ReceiveData(&opcode,1)!=SOCKET_ERROR)
	{
		int refNum;
		CString message,line;

		// response?
		if(opcode==3)
		{
			int code;

			// read the response
			ReceiveReply(refNum,code,message);
			// format the line
			line.Format("%d - %d:\t%s",refNum,code,(const char *)message);
		}
		// close message
		else if(opcode==2)
		{
			// read the reference number
			ReceiveNumber(refNum);
			// format the line
			line.Format(IDS_END_FORMAT,refNum);
		}
		// bad opcode
		else line.LoadString(IDS_BAD_OPCODE);

		// add the message
		m_responses.SetTopIndex(m_responses.AddString(line));
	}
	// close the socket
	m_socket.closesocket;
	// disable the buttons
	m_connect.EnableWindow(TRUE);
	// disable the buttons
	m_disconnect.EnableWindow(FALSE);
	// disable the buttons
	m_send.EnableWindow(FALSE);
	// disable the buttons
	m_ok.EnableWindow(TRUE);
}

int CRTS2Dialog::SendData(const void *buffer,int length)
{
	// the number of bytes sent
	int n=0;
	// send data while not enough has been sent
	while(n<length)
	{
		// send some bytes
		int n2=send(m_socket,static_cast<char *>(const_cast<void *>(buffer))+n,length-n,0);
		// return an error if it didn't work
		if(n2==0 || n2==SOCKET_ERROR) return SOCKET_ERROR;
		// account for the data sent
		n+=n2;
	}
	// return the amount of data sent
	return n;
}

int CRTS2Dialog::ReceiveData(void *buffer,int length)
{
	// the number of bytes received
	int n=0;
	// receive data while not enough has been received
	while(n<length)
	{
		// receive some bytes
		int n2=recv(m_socket,static_cast<char *>(buffer)+n,length-n,0);
		// return an error if it didn't work
		if(n2==0 || n2==SOCKET_ERROR) return SOCKET_ERROR;
		// account for the data received
		n+=n2;
	}
	// return the amount of data received
	return n;
}

int CRTS2Dialog::SendString(const CString &string)
{
	// get the length
	int length=string.GetLength();
	// encode the length
	int encodedLength=(length&0x0000FFFF);
	encodedLength|=(encodedLength^0x5555)<<16;

	// send the length
	if(SendNumber(encodedLength)==SOCKET_ERROR) return SOCKET_ERROR;
	// write the string
	return SendData(string,length&0x0000FFFF);
}

int CRTS2Dialog::ReceiveString(CString &string)
{
	int length;

	// get the length
	ReceiveNumber(length);

	// the length is in the high word and the low word
	int testLength=(length>>16)^0x00005555;
	// remove the test field
	length&=0x0000FFFF;
	// test it
	if(length!=testLength) return SOCKET_ERROR;

	// get a buffer
	char *buffer=string.GetBuffer(length);
	// read the data
	int result=ReceiveData(buffer,length);
	// release the buffer
	string.ReleaseBuffer();

	// done
	return result;
}

int CRTS2Dialog::SendNumber(int number)
{
	// convert to net order
	number=htonl(number);
	// send
	return SendData(&number,4);
}

int CRTS2Dialog::ReceiveNumber(int &number)
{
	// send
	int result=ReceiveData(&number,4);
	// convert from net order
	number=ntohl(number);
	// return the result
	return result;
}

void CRTS2Dialog::SendRequest(const CString &name,const CStringArray &parameters)
{
	// send the opcode
	SendData("\x05",1);
	// send the reference value
	SendNumber(nextRefNum++);
	// send the program name
	SendString(name);

	// get the number of parameters
	int n=parameters.GetSize();

	// send the number of parameters
	SendNumber(n);
	// send all the parameters
	for(int i=0; i<n; i++)
	{
		// get the parameter
		CString parameter=parameters.GetAt(i);
		// send it
		SendString(parameter);
	}
}

void CRTS2Dialog::ReceiveReply(int &refNum,int &code,CString &message)
{
	char temp;

	// read the reference number
	ReceiveNumber(refNum);
	// read the code
	ReceiveData(&temp,1);
	// set the code
	code=temp;
	// read the message
	ReceiveString(message);
	// read the terminating NULL
	ReceiveData(&temp,1);
}
