// CRTS2Dialog.h : header file
//

/////////////////////////////////////////////////////////////////////////////
// CRTS2Dialog dialog

class CRTS2Dialog : public CDialog
{
// Construction
public:
	CRTS2Dialog(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CRTS2Dialog)
	enum { IDD = IDD_RTS2_DIALOG };
	CButton	m_disconnect;
	CButton	m_connect;
	CListBox	m_responses;
	CButton	m_ok;
	CButton	m_send;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CRTS2Dialog)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	HICON m_hIcon;

	// Generated message map functions
	//{{AFX_MSG(CRTS2Dialog)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnSend();
	afx_msg void OnConnect();
	afx_msg void OnDisconnect();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

private:
// Data transfer helpers
	int SendData(const void *buffer,int length);
	int ReceiveData(void *buffer,int length);

	int SendString(const CString &string);
	int ReceiveString(CString &string);

	int SendNumber(int number);
	int ReceiveNumber(int &number);

// High level comm functions
	void SendRequest(const CString &name,const CStringArray &parameters);
	void ReceiveReply(int &refNum,int &code,CString &message);

// Functions for the receive thread
	static UINT ReceiveThreadFunction(LPVOID pDialog);
	void DoReceiveLoop();

// Socket data
	SOCKET m_socket;
	int m_closeRequested;
};
