// ConnectDialog.cpp : implementation file
//

#include "stdafx.h"
#include "rts2.h"
#include "ConnectDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConnectDialog dialog


CConnectDialog::CConnectDialog(SOCKET &socket, CWnd* pParent /*=NULL*/)
	: CDialog(CConnectDialog::IDD, pParent),m_socket(socket)
{
	//{{AFX_DATA_INIT(CConnectDialog)
	//}}AFX_DATA_INIT
}


void CConnectDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectDialog)
	DDX_Control(pDX, IDOK, m_ok);
	DDX_Control(pDX, IDC_COMPUTER, m_computerEdit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConnectDialog, CDialog)
	//{{AFX_MSG_MAP(CConnectDialog)
	ON_EN_CHANGE(IDC_COMPUTER, OnChangeComputer)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConnectDialog message handlers

void CConnectDialog::OnChangeComputer() 
{
	// Ok is enabled if there is text in both fileds
	m_ok.EnableWindow(m_computerEdit.GetWindowTextLength());
}

void CConnectDialog::OnOK() 
{
	SOCKADDR_IN remote={AF_INET,htons(8700),0,0};
	CString computer;

	// get the computer
	m_computerEdit.GetWindowText(computer);

	// try to get an IP address from the string
	remote.sin_addr.s_addr=inet_addr(computer);
	// if the string wasn't an IP address
	if(remote.sin_addr.s_addr==INADDR_NONE) 
	{
		CWaitCursor temp;

		// try to find the host
		hostent* host=gethostbyname(computer);
		// check that it worked
		if(!host)
		{
			// pop up a message
			AfxMessageBox(IDS_COMPUTER_NOT_FOUND,MB_OK | MB_ICONSTOP);
			// bail
			return;
		}
		// get the address
		remote.sin_addr.s_addr=*((unsigned int *)host->h_addr);
	}

	// Create an address structure for the socket
	SOCKADDR_IN local={AF_INET,0,0,0};
	
	// Create the socket
	m_socket=socket(PF_INET,SOCK_STREAM,IPPROTO_TCP);
	// bind the socket to a port
	bind(m_socket,(LPSOCKADDR)&local,sizeof(SOCKADDR_IN));

	// try to connect
	if(connect(m_socket,(LPSOCKADDR)&remote,sizeof(SOCKADDR_IN))==SOCKET_ERROR)
	{
		// pop up a message
		AfxMessageBox(IDS_CONNECTION_REFUSED,MB_OK | MB_ICONSTOP);
		// close the socket
		closesocket(m_socket);
		// bail
		return;
	}

	// done
	EndDialog(IDOK);
}
