// SendDialog.cpp : implementation file
//

#include "stdafx.h"
#include "RTS2.h"
#include "SendDialog.h"
#include "ParameterDialog.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CSendDialog dialog


CSendDialog::CSendDialog(SOCKET &socket, CWnd* pParent /*=NULL*/)
	: CDialog(CSendDialog::IDD, pParent),m_socket(socket)
{
	//{{AFX_DATA_INIT(CSendDialog)
	//}}AFX_DATA_INIT
}


void CSendDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSendDialog)
	DDX_Control(pDX, IDOK, m_ok);
	DDX_Control(pDX, IDC_REMOVE, m_remove);
	DDX_Control(pDX, IDC_PROGRAM, m_programEdit);
	DDX_Control(pDX, IDC_PARAMETERS, m_parameterList);
	DDX_Control(pDX, IDC_EDIT, m_edit);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CSendDialog, CDialog)
	//{{AFX_MSG_MAP(CSendDialog)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_EN_CHANGE(IDC_PROGRAM, OnUpdateOK)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_LBN_SELCHANGE(IDC_PARAMETERS, OnSelchangeParameters)
	ON_BN_CLICKED(IDC_REMOVE, OnRemove)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendDialog message handlers

void CSendDialog::OnAdd() 
{
	CParameterDialog dlg;

	// pop up a dialog
	if(dlg.DoModal()!=IDOK) return;
	// add the string
	m_parameterList.SetCurSel(m_parameterList.InsertString(-1,dlg.m_value));
	// enable the buttons
	m_remove.EnableWindow(TRUE);
	m_edit.EnableWindow(TRUE);
}

void CSendDialog::OnUpdateOK() 
{
	// Ok is enabled if there is text in both fileds
	m_ok.EnableWindow(m_programEdit.GetWindowTextLength());
}

void CSendDialog::OnEdit() 
{
	// get the current selection
	int n=m_parameterList.GetCurSel();

	CParameterDialog dlg;

	// set the current value
	m_parameterList.GetText(n,dlg.m_value);
	// pop up a dialog
	if(dlg.DoModal()!=IDOK) return;
	// remove the string
	m_parameterList.DeleteString(n);
	// add the string
	m_parameterList.SetCurSel(m_parameterList.InsertString(n,dlg.m_value));
}

void CSendDialog::OnSelchangeParameters() 
{
	// enable the remove and edit buttons
	m_remove.EnableWindow(TRUE);
	m_edit.EnableWindow(TRUE);
}

void CSendDialog::OnRemove() 
{
	// get the current selection
	int n=m_parameterList.GetCurSel();
	// make sure that n is still within the list
	if(n>=m_parameterList.GetCount()) n--;

	// check if there is still stuff
	if(n>=0) m_parameterList.SetCurSel(n);
	// if no items are left
	else 
	{
		// disable the buttons
		m_remove.EnableWindow(FALSE);
		m_edit.EnableWindow(FALSE);
	}
}

void CSendDialog::OnOK() 
{
	// get the program name
	m_programEdit.GetWindowText(m_program);

	// get the number of parameters
	int n=m_parameterList.GetCount();
	// make room for them in the array
	m_parameters.SetSize(n);
	// add them all
	for(int i=0; i<n; i++)
	{
		CString parameter;

		// get the parameter
		m_parameterList.GetText(i,parameter);
		// set it in the array
		m_parameters.SetAt(i,parameter);
	}

	// done
	EndDialog(IDOK);
}